Subject: IPP> Lost print Jobs

From: [email-masked]
Date: Tue, 7 Jan 1997 13:01:14 -0500

Classification:
Prologue:
Epilogue:

I think it was Scott that asked the following question:

"In HTTP is it possible for the client to send a job, the printer
bogs down in printing it, it never responds, and the client
times out or the HTTP server stack times out  waiting for
the CGI script to finish, and then resends the job and the job
is printed twice?"

I believe that using HTTP (or any other simple request-response)
protocol will work as long as we  make sure that each action is
atomic, and that client-server operations are asynchronous to
server-device operations.  For example:

  If a print job is submitted, the server responds positively once
the message is parsed correctly and the job is safe-stored.  The
response contains the job-id assigned by the server for use in
subsequent operations.

Printing occurs asynchonous to the above request/response
flow.  If the printer jams, or for some other reason cannot
complete the print job, the orginal request is not hung up - it has
 already been responded to. A subsequent request can check
status of the job.

Assuming a reliable transport, responses should not get lost.

It seems to me that if a device implements the IPP model, it must
be capable of queuing at least one job so that this asynchonicity
can be maintained. If the printer cannot do this, i.e. it prints while
receiving the job then either we claim it is not an IPP printer, or
all bets are off on dealing with Scott's problem.

---

From: [email-masked] (Bill Wagner)
Date: Tue, 7 Jan 1997 15:55:45 -0500

This seems a reasonable question and a valid response. I am not 
     pleased with the response and its implications. How large is a maximum 
     size job? Do we provide some ipp mechanism to flag overflow errors? 
     Does an IPP printer  need a hard  disk?  Or are we indeed goin to NT's 
     being used as IPP servers (which I though was the opposite the desired 
     direction?) Is IPP really going to be universal or just high end? Is 
     this spool requirement a result of the HTTP selection? Would HTTP 1.1 
     chunkyness aleviate the problem? Do others have questions about whther 
     this is really the optimum approach?

______________________________ Reply Separator _________________________________
Subject: IPP> Lost print Jobs
Author:  [email-masked] at Internet
Date:    1/7/97 1:01 PM

Classification:
Prologue:
Epilogue: